<< problem 49 - Prime permutations | Prime digit replacements - problem 51 >> |
Problem 50: Consecutive prime sum
(see projecteuler.net/problem=50)
The prime 41 can be written as the sum of six consecutive primes:
41 = 2 + 3 + 5 + 7 + 11 + 13
This is the longest sum of consecutive primes that adds to a prime below one-hundred.
The longest sum of consecutive primes below one-thousand that adds to a prime, contains 21 terms, and is equal to 953.
Which prime, below one-million, can be written as the sum of the most consecutive primes?
My Algorithm
The basic idea is pretty simple:
- generate a ton of prime numbers p
- for each sum sum_{x=i..j}{p_x} perform a primality test
- print the maximum sum that is prime
Then my first brute force code revealed a few observations:
- if the sum of the first n primes is prime, then maybe the sum of the first n+1 primes isn't
- if the sum of the first n primes isn't prime, then maybe the sum of the first n+1 primes is
Sometimes starting with the first prime 2 doesn't produce the highest sum. The problems mentions 953 which is 7 + 9 + 11 + ... + 89.
The surprising fact is that all "best" chains below 10^12 start with at most 131 (!). I can't explain why - that's just what I saw in my output !
My code generates prime numbers on-demand. Whenever the main loop runs out of primes, it calls
morePrimes(x)
which ensures that primes
will contain at x
prime numbers.On top of that,
primeSum[i]
is the sum of the first i
prime numbers (zero-based index), e.g. primeSum[2] = 2+3+5 = 10
.The interesting fact about
primeSum
is that the sum of the first x prime numbers excluding the initial y primes is primeSum[x] - primeSum[y]
.For example,
primeSum[23] - primeSum[2] = 963 - 10 = 953
, that means there is chain containing 23-2=21 elements with a sum of 953.A simple loop finds the largest sum which is below the target:
primeSum[545] = 997661
If that number isn't prime (997661 = 7 * 359 * 397), then we look at its predecessor
primeSum[544]
and so on - until the sum is prime.As I explained earlier, the best chain maybe doesn't start with the first prime.
Therefore we have to check
primeSum[545] - primeSum[0] = 997659
as well, then try primeSum[544] - primeSum[0]
, ...until we arrive at
primeSum[545] - primeSum[31]
because primes[31] = 131
.There are simple primality tests for such small number but they all fall apart when the sum is large (such as 10^12 in the Hackerrank version).
Take a look at my toolbox for inspiration.
Modifications by HackerRank
It took my quite a while to come up with a fast and stable prime test.
Searching on the internet immediately brings up the Miller-Rabin test: en.wikipedia.org/wiki/Millerâ€“Rabin_primality_test
Unfortunately, most C/C++ implementations either can't handle 64 bit numbers properly or are way to complex to fit in a few lines of code.
That's why had to write my own routine (of course inspired by looking at other sources).
Modular arithmetic was already used in problem 48, please see there for an explanation of mulmod
and powmod
.
My toolbox contains code for a 32 bit Miller-Rabin test where those two functions can be written in a much simpler way.
Note
I have to admit that the mathematics of the Miller-Rabin test is not easy to understand for a non-mathematican like me:
I couldn't have written my code without these sources of inspiration:
- some code from ronzii.wordpress.com/2012/03/04/miller-rabin-primality-test/
- with optimizations from ceur-ws.org/Vol-1326/020-Forisek.pdf
- good bases can be found at miller-rabin.appspot.com/
- 32 bit C code de.wikipedia.org/wiki/Miller-Rabin-Test
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho "1 1000" | ./50
Output:
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <iostream>
#include <vector>
// return (a*b) % modulo
unsigned long long mulmod(unsigned long long a, unsigned long long b, unsigned long long modulo)
{
// fast path
if (a <= 0xFFFFFFF && b <= 0xFFFFFFF)
return (a * b) % modulo;
// we might encounter overflows (slow path)
unsigned long long result = 0;
unsigned long long factor = a % modulo;
// bitwise multiplication
while (b > 0)
{
// b is odd ? a*b = a + a*(b-1)
if (b & 1)
{
result += factor;
if (result >= modulo)
result %= modulo;
}
// b is even ? a*b = (2*a)*(b/2)
factor <<= 1;
if (factor >= modulo)
factor %= modulo;
// next bit
b >>= 1;
}
return result;
}
// return (base^exponent) % modulo
unsigned long long powmod(unsigned long long base, unsigned long long exponent, unsigned long long modulo)
{
unsigned long long result = 1;
while (exponent > 0)
{
// fast exponentation:
// odd exponent ? a^b = a*a^(b-1)
if (exponent & 1)
result = mulmod(result, base, modulo);
// even exponent ? a^b = (a*a)^(b/2)
base = mulmod(base, base, modulo);
exponent >>= 1;
}
return result;
}
// Miller-Rabin-test
bool isPrime(unsigned long long p)
{
// some code from https://ronzii.wordpress.com/2012/03/04/miller-rabin-primality-test/
// with optimizations from http://ceur-ws.org/Vol-1326/020-Forisek.pdf
// good bases can be found at http://miller-rabin.appspot.com/
// trivial cases
const unsigned int bitmaskPrimes2to31 = (1 << 2) | (1 << 3) | (1 << 5) | (1 << 7) |
(1 << 11) | (1 << 13) | (1 << 17) | (1 << 19) |
(1 << 23) | (1 << 29); // = 0x208A28Ac
if (p < 31)
return (bitmaskPrimes2to31 & (1 << p)) != 0;
if (p % 2 == 0 || p % 3 == 0 || p % 5 == 0 || p % 7 == 0 || // divisible by a small prime
p % 11 == 0 || p % 13 == 0 || p % 17 == 0)
return false;
if (p < 17*19) // we filtered all composite numbers < 17*19, all others below 17*19 must be prime
return true;
// test p against those numbers ("witnesses")
// good bases can be found at http://miller-rabin.appspot.com/
const unsigned int STOP = 0;
const unsigned int TestAgainst1[] = { 377687, STOP };
const unsigned int TestAgainst2[] = { 31, 73, STOP };
const unsigned int TestAgainst3[] = { 2, 7, 61, STOP };
// first three sequences are good up to 2^32
const unsigned int TestAgainst4[] = { 2, 13, 23, 1662803, STOP };
const unsigned int TestAgainst7[] = { 2, 325, 9375, 28178, 450775, 9780504, 1795265022, STOP };
// good up to 2^64
const unsigned int* testAgainst = TestAgainst7;
// use less tests if feasible
if (p < 5329)
testAgainst = TestAgainst1;
else if (p < 9080191)
testAgainst = TestAgainst2;
else if (p < 4759123141ULL)
testAgainst = TestAgainst3;
else if (p < 1122004669633ULL)
testAgainst = TestAgainst4;
// find p - 1 = d * 2^j
auto d = p - 1;
d >>= 1;
unsigned int shift = 0;
while ((d & 1) == 0)
{
shift++;
d >>= 1;
}
// test p against all bases
do
{
auto x = powmod(*testAgainst++, d, p);
// is test^d % p == 1 or -1 ?
if (x == 1 || x == p - 1)
continue;
// now either prime or a strong pseudo-prime
// check test^(d*2^r) for 0 <= r < shift
bool maybePrime = false;
for (unsigned int r = 0; r < shift; r++)
{
// x = x^2 % p
// (initial x was test^d)
x = powmod(x, 2, p);
// x % p == 1 => not prime
if (x == 1)
return false;
// x % p == -1 => prime or an even stronger pseudo-prime
if (x == p - 1)
{
// next iteration
maybePrime = true;
break;
}
}
// not prime
if (!maybePrime)
return false;
} while (*testAgainst != STOP);
// prime
return true;
}
std::vector<unsigned int> primes;
std::vector<unsigned long long> primeSum;
// make sure that at least "num" primes are available in "primes"
void morePrimes(unsigned int num)
{
if (primes.empty())
{
primes .reserve(400000);
primeSum.reserve(400000);
primes.push_back(2);
primes.push_back(3);
primeSum.push_back(2);
}
for (auto i = primes.back() + 2; primes.size() <= num; i += 2)
{
bool isPrime = true;
// test against all prime numbers we have so far (in ascending order)
for (auto x : primes)
{
// prime is too large to be a divisor
if (x*x > i)
break;
// divisible => not prime
if (i % x == 0)
{
isPrime = false;
break;
}
}
// yes, we have a prime
if (isPrime)
primes.push_back(i);
}
for (auto i = primeSum.size(); i < primes.size(); i++)
primeSum.push_back(primeSum.back() + primes[i]);
}
int main()
{
// generate some primes
const unsigned int PrimesPerBatch = 10000;
morePrimes(PrimesPerBatch);
unsigned int tests;
std::cin >> tests;
while (tests--)
{
unsigned long long last = 1000000;
std::cin >> last;
unsigned long long best = 2; // highest prime sum
unsigned int maxLength = 0; // longest chain (must add plus one)
// all sequences start with surprisingly small prime numbers
// a brute-force search showed that all "good" chains start at 2..131
unsigned int start = 0; // primes[0] = 2
while (primes[start] <= 131 && primes[start] <= last)
{
unsigned long long subtract = 0;
if (start > 0)
subtract = primeSum[start - 1];
unsigned int pos = start + maxLength;
// find shortest chain whose sum exceeds the limit
while (primeSum[pos] - subtract <= last)
{
pos++;
// running out of prime numbers ? add more !
if (pos + 100 >= primes.size()) // plus 100 is probably too cautious
morePrimes(primes.size() + PrimesPerBatch);
}
pos--;
// chop off one prime number until the sum is prime, too
while (pos - start > maxLength)
{
unsigned long long sum = primeSum[pos] - subtract;
// yes, we have a good candidate (maybe better ones for other values of "start", though)
if (isPrime(sum))
{
maxLength = pos - start;
best = sum;
break;
}
pos--;
}
start++;
}
// if sum is > 0 then "length" didn't count the first element
if (best >= 2)
maxLength++;
std::cout << best << " " << maxLength << std::endl;
}
return 0;
}
This solution contains 38 empty lines, 46 comments and 2 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in less than 0.01 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
February 27, 2017 submitted solution
April 20, 2017 added comments
Hackerrank
see https://www.hackerrank.com/contests/projecteuler/challenges/euler050
My code solves 10 out of 10 test cases (score: 100%)
Difficulty
Project Euler ranks this problem at 5% (out of 100%).
Hackerrank describes this problem as hard.
Note:
Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.
In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.
Similar problems at Project Euler
Problem 58: Spiral primes
Problem 60: Prime pair sets
Note: I'm not even close to solving all problems at Project Euler. Chances are that similar problems do exist and I just haven't looked at them.
Links
projecteuler.net/thread=50 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
C# www.mathblog.dk/project-euler-50-sum-consecutive-primes/ (written by Kristian Edlund)
Python github.com/hughdbrown/Project-Euler/blob/master/euler-050.py (written by Hugh Brown)
Python github.com/nayuki/Project-Euler-solutions/blob/master/python/p050.py (written by Nayuki)
Python github.com/sefakilic/euler/blob/master/python/euler050.py (written by Sefa Kilic)
Python github.com/smacke/project-euler/blob/master/python/50.py (written by Stephen Macke)
C++ github.com/HaochenLiu/My-Project-Euler/blob/master/050.cpp (written by Haochen Liu)
C++ github.com/Meng-Gen/ProjectEuler/blob/master/50.cc (written by Meng-Gen Tsai)
Java github.com/dcrousso/ProjectEuler/blob/master/PE050.java (written by Devin Rousso)
Java github.com/nayuki/Project-Euler-solutions/blob/master/java/p050.java (written by Nayuki)
Java github.com/thrap/project-euler/blob/master/src/Java/Problem50.java (written by Magnus Solheim Thrap)
Javascript github.com/dsernst/ProjectEuler/blob/master/50 Consecutive prime sum.js (written by David Ernst)
Go github.com/frrad/project-euler/blob/master/golang/Problem050.go (written by Frederick Robinson)
Mathematica github.com/nayuki/Project-Euler-solutions/blob/master/mathematica/p050.mathematica (written by Nayuki)
Mathematica github.com/steve98654/ProjectEuler/blob/master/050.nb
Haskell github.com/roosephu/project-euler/blob/master/50.hs (written by Yuping Luo)
Clojure github.com/rm-hull/project-euler/blob/master/src/euler050.clj (written by Richard Hull)
Scala github.com/samskivert/euler-scala/blob/master/Euler050.scala (written by Michael Bayne)
Perl github.com/gustafe/projecteuler/blob/master/050-Consecutive-prime-sum.pl (written by Gustaf Erikson)
Rust github.com/gifnksm/ProjectEulerRust/blob/master/src/bin/p050.rs
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 49 - Prime permutations | Prime digit replacements - problem 51 >> |